Attribute VB_Name = "GLOBAL"
Option Explicit

' Softwave information
Global Const VERSION = "2"
Global Const REVISION = "b"

' Configuration information.
Global Const DefPort = 0    'The default port is com1; 2: com2 ...
Global Const DefBaud = 0    'The default baudrate is 9600;


' File Open/Save Dialog Flags
Global Const OFN_OVERWRITEPROMPT = &H2&
Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_FILEMUSTEXIST = &H1000&

' MsgBox parameters
Global Const MB_YESNO = 4
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons
Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

' Show parameters
Global Const MODAL = 1
Global Const MODELESS = 0

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed
Global Const IDCONTINUE = 8            ' Continue button pressed

' Commands to pass WinHelp()
Global Const HELP_CONTEXT = &H1 '  Display topic in ulTopic
Global Const HELP_QUIT = &H2    '  Terminate help
Global Const HELP_INDEX = &H3   '  Display index
Global Const HELP_HELPONHELP = &H4      '  Display help on using help
Global Const HELP_SETINDEX = &H5        '  Set the current Index for multi index help
Global Const HELP_KEY = &H101           '  Display topic for keyword in offabData
Global Const HELP_MULTIKEY = &H201

' Window 3.1 commands to pass WinHelp()
'Global Const HELP_CONTENTS = &H3     ' Display Help for a particular topic
'Global Const HELP_SETCONTENTS = &H5  ' Display Help contents topic
'Global Const HELP_CONTEXTPOPUP = &H8 ' Display Help topic in popup window
'Global Const HELP_FORCEFILE = &H9    ' Ensure correct Help file is displayed
'Global Const HELP_COMMAND = &H102    ' Execute Help macro
'Global Const HELP_PARTIALKEY = &H105 ' Display topic found in keyword list
'Global Const HELP_SETWINPOS = &H203  ' Display and position Help window

' Win Constants
Global Const WF_CPU286 = &H2&
Global Const WF_CPU386 = &H4&
Global Const WF_CPU486 = &H8&
Global Const WF_STANDARD = &H10&
Global Const WF_ENHANCED = &H20&
Global Const WF_80x87 = &H400&

' Win32
Public Const PROCESSOR_INTEL_386 = 386
Public Const PROCESSOR_INTEL_486 = 486
Public Const PROCESSOR_INTEL_PENTIUM = 586
Public Const PROCESSOR_MIPS_R4000 = 4000
Public Const PROCESSOR_ALPHA_21064 = 21064


' Global variables
Global gblCurPos%   'Current position filter.
Global gblMaxFtr%   'Maximum number of filters.
Global gblQuit%     'True/False.
Global gblABtype%, gblABtypeS$   '1 for 301, 2 for 302, and 3 for 303.
Global gblCancel%   'True or False
Global Serial&
Global gblInitCom%
Global gblOkCancel%, gblContinueCancel%
Global gblBaud&, gblPortNo&
'Global gblSSpeed%, gblCurSize%
Global gblIniExist% 'True: if cm11x.ini exists.
Global gblAddr%     'gblOVal%, gblNVal%

Type MEMORYSTATUS   '  32 Bytes
        dwLength As Long
        dwMemoryLoad As Long
        dwTotalPhys As Long
        dwAvailPhys As Long
        dwTotalPageFile As Long
        dwAvailPageFile As Long
        dwTotalVirtual As Long
        dwAvailVirtual As Long
End Type

Type SYSTEM_INFO  '  36  Bytes
        dwOemID As Long
        dwPageSize As Long
        lpMinimumApplicationAddress As Long
        lpMaximumApplicationAddress As Long
        dwActiveProcessorMask As Long
        dwNumberOrfProcessors As Long
        dwProcessorType As Long
        dwAllocationGranularity As Long
        wProcessorLevel As Integer
        wProcessorRevision As Integer
End Type

' DLL's declarations
'Declare Function WinHelp Lib "User" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Any) As Integer
'Declare Function GetFreeSpace Lib "Kernel" (ByVal wFlags As Integer) As Long
'Declare Function GetFreeSystemResources Lib "User" (ByVal fuSysResource As Integer) As Integer
'Declare Function GetWinFlags Lib "Kernel" () As Long
Declare Function GetPrivateProfileInt& Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String)
'Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Integer, ByVal lpFilename As String) As Integer
'Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFilename As String) As Integer
'Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpString As String, ByVal lplFileName As String) As Integer
Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As String, ByVal lpFileName As String)
Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)


Sub ABtypeInit()
  Select Case gblABtype%
    Case 1  'AB301
      gblMaxFtr% = 6        '6 filters
      gblABtypeS$ = "AB301"
    Case 2  'AB302
      gblMaxFtr% = 5        '5 filters
      gblABtypeS$ = "AB302"
    Case 3  'AB303
      gblMaxFtr% = 12       '12 filters
      gblABtypeS$ = "AB303"
    Case 4  'AB304 ~B Version B
      ' change from V2a to V2b (now 12, previous 14)
      gblMaxFtr% = 12       '12 filters
      gblABtypeS$ = "AB304"
    Case Else
      Beep
  End Select
  frmAbDemo.mnuAB(gblABtype% - 1).Enabled = True
  frmAbDemo.mnuAB(gblABtype% - 1).Checked = True
  frmAbDemo.lblModel.Caption = "Model : " & gblABtypeS$
  frmAbDemo.lblSerial.Caption = "Serial : " & Str$(Serial&)
  
End Sub

Sub Centerform(X As Form)
  X.Top = Screen.Height / 2 - X.Height / 2
  X.Left = Screen.Width / 2 - X.Width / 2
End Sub

Function COMInit%(PortNo&, Baudrate&)
 'Returns true if success; otherwise this function returns false.
  Dim Status%, BaudLocal%, PortLocal&
  ' Remember: will get portnumber, and baudrate.
  On Error GoTo COMInitErr
  PortLocal& = PortNo& + 1
  BaudLocal% = 9600 / 2 ^ Baudrate&
  Status% = ABInitComPort%(PortLocal&, BaudLocal%, frmAbDemo.comComm1)
  If Status% > 127 Then
    'An error has occurred.
    COMInit% = False
  Else
    COMInit% = COMTest%()
  End If
COMInitResume:
  Exit Function

COMInitErr:
  MsgBox "Error code is : " & Err, MB_ICONEXCLAMATION, "Init. Comm. Port Error"
  Resume COMInitResume

End Function

Function COMTest%()
  'Returns true if success; otherwise this function returns false.
  Dim Status%
  On Error GoTo COMTestErr
  'MsgBox "Sending :  27 ", MB_ICONINFORMATION, "Init. Comm. Port"
  Status% = ABEcho%(frmAbDemo.comComm1, 1)   '1: is Timeout% in seconds
  If Status% > 127 Then
    MsgBox "The Filter Wheel is not responding ", MB_ICONQUESTION, "Init. Comm. Port"
    gblInitCom% = False
    COMTest% = False
  Else
    gblInitCom% = True
    COMTest% = True
  End If

COMTestResume:
  Exit Function

COMTestErr:
  MsgBox "Error code is : " & Err, MB_ICONEXCLAMATION, "Init. Comm. Port Error"
  Resume COMTestResume

End Function

Sub Delay(Seconds!)
  Dim FinishTime
  FinishTime = Timer + Seconds!
  While Timer < FinishTime: Wend

End Sub

Function GetAbInit%()
' If ab30x.ini doesn't exist, then this function will return False;
' otherwise, it will return true.
' subAB%: 1 for 301, 2 for 302, and 3 for 303.
  Dim subPort&, subBaud&, subAB%
  Dim Ret%
  
  subPort& = GetPrivateProfileInt&("AB30X", "Port", -1, "ab30x.ini")
  If subPort& = -1 Then
    GetAbInit% = False
  Else
    GetAbInit% = True
    subBaud& = GetPrivateProfileInt&("AB30X", "Baud", -1, "ab30x.ini")
    gblPortNo& = subPort&
    gblBaud& = subBaud&
End If
  
  
  
  

End Function

Sub InitQueries()
  Dim Position%, Status%, Timeout%, WordRd&
  Timeout% = 2 * 2 ^ gblBaud&

  ' Query current position
  Status% = ABQueryPos%(Position%, frmAbDemo.comComm1, Timeout%) '5: 5s Timeout%
  If Status% > 127 Then
    gblCurPos% = 1
    GoTo ErrMessage
  Else
    gblCurPos% = Position%
  End If
  
  Status% = ABEepromRead%(2, WordRd&, frmAbDemo.comComm1, Timeout%)
  If Status% > 127 Then
    GoTo ErrMessage
  Else
    Select Case WordRd&
      Case 301
        gblABtype% = 1
        frmAbDemo.mnuAB(0).Checked = True
      Case 302
        gblABtype% = 2
        frmAbDemo.mnuAB(1).Checked = True
      Case 303
        gblABtype% = 3
        frmAbDemo.mnuAB(2).Checked = True
      Case 304  '~B added 304
        gblABtype% = 4
        frmAbDemo.mnuAB(3).Checked = True
      Case Else
        gblABtype% = 1
        frmAbDemo.mnuAB(0).Checked = True
    End Select
  End If
  'Query for Serial Number
  Status% = ABEepromRead%(13, WordRd&, frmAbDemo.comComm1, Timeout%)
  If Status% > 127 Then
    GoTo ErrMessage
  Else
    Serial& = WordRd&
  End If
    
  Exit Sub
  
ErrMessage:
  MsgBox "An error has occurred !", MB_ICONSTOP, "AB Demo"

End Sub

Function SaveAbInit%()
' This function returns true if it is succeful.
' Otherwise, it is false.
  Dim subPort&, subBaud&, subAB%
  Dim Ret1&, Ret2&, Ret3&
  subPort& = gblPortNo&
  subBaud& = gblBaud&
  subAB% = gblABtype%   '1: 301, 2: 302, 3: 303
    
'Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" ()
'(ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As String,
'ByVal lpFileName As String)
    
  Ret1& = WritePrivateProfileString&("AB30X", ByVal "Port", Str$(subPort&), "ab30x.ini")
  Ret2& = WritePrivateProfileString&("AB30X", ByVal "Baud", Str$(subBaud&), "ab30x.ini")
  Ret3& = WritePrivateProfileString&("AB30X", ByVal "ABtype", Str$(subAB%), "ab30x.ini")
  If Ret1& = 0 Or Ret2& = 0 Or Ret3& = 0 Then
    SaveAbInit% = False
  Else
    SaveAbInit% = True
  End If

End Function

Sub SaveConfig()
  Dim Baud$
  If gblInitCom% Then
    If SaveAbInit%() Then
      Baud$ = Str$(9600 / (2 ^ gblBaud&))
      MsgBox "COM " & gblPortNo& + 1 & " and " & Baud$ & " Baud rate have been saved. ", , "AB Demo"
    Else
      MsgBox "An error has occurred. The current configuration cannot be saved. ", , "AB Demo"
    End If
  Else
    MsgBox "Did you initialize a serial port ? ", , "AB Demo"
  End If

End Sub

Sub TopLeftform(X As Form)
  X.Top = 0
  X.Left = 0

End Sub

